﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;

namespace Torture
{
    public class FlatSliceBlade : MonoBehaviour
    {
        public Vector2 axis = Vector2.down;
        public bool looseUpper = false;
        public bool looseLower = true;
        public float lowerLimit = 0;
        public float higherLimit = 0.1f;
        public bool canSlice = true;
        public void Start()
        {
            var physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
            var physicalProperties = ModAPI.FindPhysicalProperties("Metal").ShallowClone();
            physicalProperties.Sharp = true;
            physicalProperties.SharpAxes = new SharpAxis[]
            {
                new SharpAxis(axis, lowerLimit, higherLimit, looseUpper, looseLower)
            };
            physicalBehaviour.Properties = physicalProperties;
        }
        private void Lodged(Stabbing stabbing)
        {
            if(stabbing.victim.TryGetComponent<LimbBehaviour>(out LimbBehaviour limb) && canSlice)
            {
                limb.Slice();
            }
        }
    }
    public class SkinRemovalBlade : MonoBehaviour
    {
        public BoxCollider2D collider;
        public void Start()
        {
            var colliderHandler = Utility.CreateChildObject("colliderHandler", gameObject.transform);
            Utility.SetPositionWithOffSet(colliderHandler.transform, gameObject.transform, 0.08f, -0.05f);
            collider = colliderHandler.AddComponent<BoxCollider2D>();
            collider.size = new Vector2(0.45f, 0.1f);

            var physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
            var physicalProperties = ModAPI.FindPhysicalProperties("Metal").ShallowClone();
            physicalProperties.Sharp = true;
            physicalProperties.SharpAxes = new SharpAxis[]
            {
                new SharpAxis(Vector2.down, 0, 0.1f, false, true)
            };
            physicalBehaviour.Properties = physicalProperties;
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if (collision.gameObject.TryGetComponent<LimbBehaviour>(out LimbBehaviour limb) && Utility.InCollider(collider).Contains(collision.collider))
            {
                var point = collision.contacts[0].point;
                limb.SkinMaterialHandler.AddDamagePoint(DamageType.Stab, point, UnityEngine.Random.Range(15f, 40f));
                if(UnityEngine.Random.Range(0, 100) > 80)
                {
                    limb.CirculationBehaviour.Cut(point, new Vector2(point.x + -gameObject.transform.position.x, point.y));
                }
            }
        }
    }
}
