﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using System.Reflection;
using System.Collections;
using System.Threading.Tasks;
using System.Linq;

namespace Torture
{
    public class Mod
    {
        public static void OnLoad()
        {
            if (!Utility.IsFolderExists(@"Mods\\01STUDIO\\Torture"))
            {
                Utility.CreateFolder(@"Mods\\01STUDIO\\Torture");
                DialogBox trailer = (DialogBox)null;
                DialogBox discordInvite = (DialogBox)null;
                trailer = DialogBoxManager.Dialog("Hello, my little lover of torment, do you want to see what I have prepared for you with my team?", new DialogButton[]
                {
                    new DialogButton("Let's skip this", true, () =>
                    {
                        Utility.ShowDialog(discordInvite);
                    }),
                    new DialogButton("Absolutely, let's see", true, () =>
                    {
                        Utility.OpenLink("https://youtu.be/TdZGXQy5Ofo");
                        Utility.ShowDialog(discordInvite);
                    })
                });
                discordInvite = DialogBoxManager.Dialog("Hi, this mod is one of the biggest I've ever done\nA huge amount of work has been done in it, below you can leave your feedback.", new DialogButton[]
                {
                    new DialogButton("Join the community on Discord", false, () =>
                    {
                        Utility.OpenLink("https://discord.gg/tUvF8jmbWm");
                    }),
                    new DialogButton("Support Team 01 (Patreon analog)", false, () =>
                    {
                        Utility.OpenLink("https://boosty.to/dyadyushkadyadya");
                    }),
                    new DialogButton("Close forever", true, () => DialogBoxManager.Notification("Thanks for installing the mod. \nYours 01 Studio"))
                });
                Utility.HideDialog(discordInvite);
            }
        }
        public static void Main()
        {
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                CategoryOverride = ModAPI.FindCategory("Melee"),
                NameOverride = "[Torture Mod] Bear Trap",
                NameToOrderByOverride = "Torture1",
                DescriptionOverride = "A device designed to catch or kill a victim, as well as serving as a protective barrier.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/bearTrap_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Bear Trap/";
                    Sprite[] sprites = new Sprite[] { ModAPI.LoadSprite(path + "left.png"), ModAPI.LoadSprite(path + "plate.png"), ModAPI.LoadSprite(path + "right.png") };

                    var behaviour = gameObject.GetOrAddComponent<BearTrapBehaviour>();
                    behaviour.sprites = sprites;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                CategoryOverride = ModAPI.FindCategory("Melee"),
                NameOverride = "[Torture Mod] Guillotine Blade",
                NameToOrderByOverride = "Torture2",
                DescriptionOverride = "A very sharpened piece of metal.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/guillotineBlade_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Guillotine Blade/";
                    Utility.SetSprite(gameObject, ModAPI.LoadSprite(path + "sprite.png"));
                    gameObject.AddComponent<FlatSliceBlade>();
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                CategoryOverride = ModAPI.FindCategory("Melee"),
                NameOverride = "[Torture Mod] Skin Removal Knife",
                NameToOrderByOverride = "Torture3",
                DescriptionOverride = "Its blade is not clearly sharpened and any of its holding on the surface of your skin will lead to damage, be careful",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/skinRemovalKnife_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Skin Removal Knife/";
                    Sprite[] sprites = new Sprite[] { ModAPI.LoadSprite(path + "sprite.png") };
                    gameObject.SetSprite(sprites[0]);
                    var physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
                    physicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                    physicalBehaviour.HoldingPositions = new Vector3[] { new Vector3(0, 0, 0) };
                    gameObject.AddComponent<SkinRemovalBlade>();
                    physicalBehaviour.ResetColliderArray();


                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                CategoryOverride = ModAPI.FindCategory("Melee"),
                NameOverride = "[Torture Mod] Katana",
                NameToOrderByOverride = "Torture4",
                DescriptionOverride = "A long Japanese sword. The shape of the katana blade resembles a saber, but the handle is straight and long, which allows you to use a two-handed grip. The pommel is missing.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/katana_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Katana/";
                    Sprite[] sprites = new Sprite[] { ModAPI.LoadSprite(path + "katana.png") };
                    Utility.SetSprite(gameObject, sprites[0], false);
                    UnityEngine.Object.Destroy(gameObject.GetComponent<Collider2D>());
                    var objectCollider = gameObject.AddComponent<BoxCollider2D>();
                    objectCollider.size = new Vector2(1.3286f, 0.1f);
                    objectCollider.offset = new Vector2(0.05f, 0.01f);
                    var handlePhysicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
                    handlePhysicalBehaviour.HoldingPositions = new Vector3[] { new Vector3(-0.4f, 0, 0) };
                    var bladeBehaviour = gameObject.AddComponent<FlatSliceBlade>();
                    bladeBehaviour.axis = Vector2.right;
                    bladeBehaviour.looseLower = false;
                    bladeBehaviour.looseUpper = true;
                    bladeBehaviour.higherLimit = 0.4f;
                    GameObject point = Utility.CreateChildObject("point", gameObject.transform);
                    var boxCollider = point.AddComponent<BoxCollider2D>();
                    boxCollider.isTrigger = true;
                    boxCollider.size = new Vector2(0.9f, 0.1f);
                    Utility.SetPositionWithOffSet(point.transform, gameObject.transform, 0.3276f, -0.1012f);
                    var actOnCollide = gameObject.AddComponent<ActOnCollideOwn>();
                    actOnCollide.DispatchChance = 1f;
                    actOnCollide.ImpactForceThreshold = 0.4f;
                    actOnCollide.Actions = (collision) =>
                    {
                        var colliders = Utility.InCollider(boxCollider);
                        if (colliders.Contains(collision.collider))
                        {
                            if (collision.gameObject.TryGetComponent<LimbBehaviour>(out LimbBehaviour limb))
                            {
                                limb.Slice();
                            }
                        }
                    };
                    handlePhysicalBehaviour.ResetColliderArray();
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                NameOverride = "[Torture Mod] Microwave Oven",
                NameToOrderByOverride = "Torture1",
                DescriptionOverride = "An electrical appliance that allows you to warm up water-containing substances due to electromagnetic radiation of the decimeter range and designed for fast cooking, heating or defrosting of food.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/microwave_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Microwave/";
                    string pathSounds = "Sounds/Microwave/";
                    var microwaveBehaviour = gameObject.AddComponent<Microwave>();
                    microwaveBehaviour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "background.png"), ModAPI.LoadSprite(path + "glass.png"), ModAPI.LoadSprite(path + "foreground.png") };
                    microwaveBehaviour.audioClips = new AudioClip[] { ModAPI.LoadSound(pathSounds + "rumble.wav"), ModAPI.LoadSound(pathSounds + "ding.wav") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                NameOverride = "[Torture Mod] Freezer",
                NameToOrderByOverride = "Torture2",
                DescriptionOverride = "A device that maintains a low temperature in a thermally insulated chamber.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/freezer_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Freezer/";
                    var freezerBehaviour = gameObject.AddComponent<Freezer>();
                    freezerBehaviour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "sides.png"), ModAPI.LoadSprite(path + "transparent_foreground.png"), ModAPI.LoadSprite(path + "foreground.png"), ModAPI.LoadSprite(path + "door.png") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                NameOverride = "[Torture Mod] Circular Table",
                NameToOrderByOverride = "Torture3",
                DescriptionOverride = "A machine designed for longitudinal, transverse sawing and angled sawing of wood and other materials.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/circularTable_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Circular Table/";
                    string pathSounds = "Sounds/Saw/";
                    var circularTableBehaviour = gameObject.AddComponent<CircularTable>();
                    circularTableBehaviour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "table.png"), ModAPI.LoadSprite(path + "saw.png") };
                    circularTableBehaviour.audioClips = new AudioClip[] { ModAPI.LoadSound(pathSounds + "Middle_Saw.mp3") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Metal Pole"),
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                NameOverride = "[Torture Mod] Water Torture Cell",
                NameToOrderByOverride = "Torture4",
                DescriptionOverride = "Fill this chamber with any liquid you want. And if it happens, put a human being in there.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/waterCell_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Water Torture Cell/";
                    var waterTortureCell = gameObject.GetOrAddComponent<WaterTortureCell>();
                    waterTortureCell.sprites = new Sprite[] { ModAPI.LoadSprite(path + "sprite.png") };
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                CategoryOverride = ModAPI.FindCategory("Melee"),
                NameOverride = "[Torture Mod] Shocker",
                NameToOrderByOverride = "Torture5",
                DescriptionOverride = "A weapon whose principle of operation is based on the direct action of an electric discharge on a live target is one of the devices for self-defense. It belongs to the class of non-lethal weapons.",
                ThumbnailOverride = ModAPI.LoadSprite("Sprites/Other/shocker_Thumb.png"),
                AfterSpawn = (gameObject) =>
                {
                    string path = "Sprites/Art/Shocker/";
                    string pathSounds = "Sounds/Shocker/";
                    var shockerBehvaiour = gameObject.AddComponent<Shocker>();
                    shockerBehvaiour.sprites = new Sprite[] { ModAPI.LoadSprite(path + "sprite.png") };
                    shockerBehvaiour.audioClips = new AudioClip[] { ModAPI.LoadSound(pathSounds + "shocker.wav") };
                }
            });
        }
    }
}